Draft Downgrade: Difference between revisions

From FreeCAD Documentation
m (→‎Exemple: minor)
No edit summary
Line 1: Line 1:
<translate>
{{GuiCommand|Name=Draft_Downgrade|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]|MenuLocation=Draft -> Downgrade|Shortcut=D N|SeeAlso=[[Draft Upgrade]]}}
{{GuiCommand|Name=Draft_Downgrade|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]|MenuLocation=Draft -> Downgrade|Shortcut=D N|SeeAlso=[[Draft Upgrade]]}}


Line 5: Line 6:
This tool downgrades selected objects in different ways. If no object is selected, you will be invited to select one.
This tool downgrades selected objects in different ways. If no object is selected, you will be invited to select one.


</translate>
[[Image:Draft_Downgrade_example.jpg|400px]]
[[Image:Draft_Downgrade_example.jpg|400px]]
<translate>


==How to use==
==How to use==
Line 21: Line 24:


==Example==
==Example==

{{clear}}
<br>
<center>
<gallery widths="300" heights="200">
<gallery widths="300" heights="200">
File:Draft Downgrade 01.png| Complete form
File:Draft Downgrade 01.png|Complete shape
File:Draft Downgrade 02.png|Form with disconnected and split faces
File:Draft Downgrade 02.png|Downgraded shape, with disconnected and split faces
</gallery>
</gallery>
</center>
{{clear}}


==Scripting==
==Scripting==


The Downgrade tool cannot be scripted directly, but it is easy to reproduce its different operations. See the [[Part Cut]] page.
The Downgrade tool can be used in python scripts and [[macros]] by using the following function:

</translate>
<syntaxhighlight>
downgrade (objects [delete], [force])
</syntaxhighlight>
<translate>

* Downgrades the given object(s) (can be an object or a list of objects).
* If delete is True, old objects are deleted.
* The force attribute can be used to force a certain way of downgrading. It can be: explode, shapify, subtr, splitFaces, cut2, getWire, splitWires.
* Returns a dictionnary containing two lists, a list of new objects and a list of objects to be deleted

Example:

</translate>
<syntaxhighlight>
import FreeCADGui,Draft
selection = FreeCADGui.Selection.getSelection()
Draft.downgrade(selection)
</syntaxhighlight>


<languages/>
{{languages | {{es|Draft Downgrade/es}} {{fr|Draft Downgrade/fr}} {{it|Draft Downgrade/it}} {{se|Draft Downgrade/se}} }}

Revision as of 17:19, 13 February 2014

Draft_Downgrade

Menu location
Draft -> Downgrade
Workbenches
Draft, Arch
Default shortcut
D N
Introduced in version
-
See also
Draft Upgrade

Description

This tool downgrades selected objects in different ways. If no object is selected, you will be invited to select one.

How to use

  1. Select one or more objects you widh to downgrade
  2. Press the Draft Downgrade button or press D then N keys

Options

The selected objects are modified/downgraded, according to the following conditions (in order):

  • if only one object is selected and it contains more than one face, each face becomes a separate object
  • if there are more than one face in the selection, the subsequent objects are subtracted from the first one
  • if there is only one face in the selection, it gets converted into a wire
  • otherwise all wires found in the selection are exploded into single edges

Example

Scripting

The Downgrade tool can be used in python scripts and macros by using the following function:

 downgrade (objects [delete], [force])
  • Downgrades the given object(s) (can be an object or a list of objects).
  • If delete is True, old objects are deleted.
  • The force attribute can be used to force a certain way of downgrading. It can be: explode, shapify, subtr, splitFaces, cut2, getWire, splitWires.
  • Returns a dictionnary containing two lists, a list of new objects and a list of objects to be deleted

Example:

 import FreeCADGui,Draft
 selection = FreeCADGui.Selection.getSelection()
 Draft.downgrade(selection)